
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17: http://docutils.sourceforge.net/" />

    <title>Welcome to the specage documentation! &#8212; specage 0.01a documentation</title>
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="welcome-to-the-specage-documentation">
<h1>Welcome to the specage documentation!<a class="headerlink" href="#welcome-to-the-specage-documentation" title="Permalink to this headline">¶</a></h1>
<section id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>Welcome to specage. The Python library for basic data interpretation in optical
spectroscopy, with broad applicability (IR, Vis, UV, Fluorescence,…).</p>
<p>specage is intended to be a basic package that allows to apply common methods
such as base line operations peak -find or -fit, integration and others to
optical spectroscopic data sets.</p>
<p>The actual acquisition or sampling method is only important for the data
reading part which in this package is achieved by specific reader functions
(“readers”). The task of the reader is to create spectral objects (Spectrum,
TimeSeries, SpectralSum) provided by the specage.spcl library. The spectral
classes provide the methods commonly applied to all sorts of optical
spectroscopy.</p>
<p>At the moment readers for spectroscopic instruments in the Interface
Spectroscopy group of the MPIE are available. For specage to become a useful
tool for many people it is desired that people write and share their own
readers and methods for the spectral classes. In case you miss a method or
feature and do not know hoe to add it to specage or any other questions or
suggestions please contact Martin Rabe.</p>
<p>Installation in a nutshell:</p>
<dl class="simple">
<dt>There is no installer yet, feel free to write one, otherwise you may:</dt><dd><ol class="arabic simple">
<li><p>Install Python3</p></li>
<li><p>Install Python packages astropy, numpy, matplotlib, (spc)</p></li>
<li><p>Clone or download specage</p></li>
<li><p>Add the path containing specage to your PYTHONPATH</p></li>
<li><p>optional: look at the example.py</p></li>
</ol>
</dd>
</dl>
</section>
<section id="module-specage.spcl">
<span id="classes"></span><h2>Classes<a class="headerlink" href="#module-specage.spcl" title="Permalink to this headline">¶</a></h2>
<dl class="simple">
<dt>Spectral Class Library:</dt><dd><p>The classes Spectrum, TimeSeries and</p>
</dd>
</dl>
<p>&#64;author: Martin Rabe, 2016-2018</p>
<dl class="py class">
<dt id="specage.spcl.SeriesIterator">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">specage.spcl.</span></code><code class="sig-name descname"><span class="pre">SeriesIterator</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">series</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SeriesIterator" title="Permalink to this definition">¶</a></dt>
<dd><p>Iterator class for TimeSeries and Spectralseries</p>
</dd></dl>

<dl class="py class">
<dt id="specage.spcl.SpectralSeries">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">specage.spcl.</span></code><code class="sig-name descname"><span class="pre">SpectralSeries</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">ListofSpectra</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">c</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">FileNames</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cName</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'c'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cUnit</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries" title="Permalink to this definition">¶</a></dt>
<dd><p>Merged Spectrum or SpectralSum objects, giving access to interpretation 
of spectral variations depending on a control variable c. Similar to 
TimeSeries, but more general</p>
<dl class="py method">
<dt id="specage.spcl.SpectralSeries.cmean">
<code class="sig-name descname"><span class="pre">cmean</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">boxwidth</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.cmean" title="Permalink to this definition">¶</a></dt>
<dd><p>Return new SpectralSeries object with averaged spectra. The number of 
spectra to be averaged is determined by boxwidth. Attention: Comments 
of the original data set are lost in this operation.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_cname">
<code class="sig-name descname"><span class="pre">get_cname</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_cname" title="Permalink to this definition">¶</a></dt>
<dd><p>Return unit of time. Not necessary when timestamps are of class 
datetime.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_cunit">
<code class="sig-name descname"><span class="pre">get_cunit</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_cunit" title="Permalink to this definition">¶</a></dt>
<dd><p>Return unit of time. Not necessary when timestamps are of class 
datetime.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_filenames">
<code class="sig-name descname"><span class="pre">get_filenames</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_filenames" title="Permalink to this definition">¶</a></dt>
<dd><p>Return filenames</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_intarr">
<code class="sig-name descname"><span class="pre">get_intarr</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_intarr" title="Permalink to this definition">¶</a></dt>
<dd><p>Return array of intensities.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_peakbaselines">
<code class="sig-name descname"><span class="pre">get_peakbaselines</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_peakbaselines" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy array with wavenumbers and numpy array with baselines</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_peaks">
<code class="sig-name descname"><span class="pre">get_peaks</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_peaks" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy array with wavenumbers and numpy array with peaks</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_size">
<code class="sig-name descname"><span class="pre">get_size</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_size" title="Permalink to this definition">¶</a></dt>
<dd><p>Return number of spectrum objects</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_spectra">
<code class="sig-name descname"><span class="pre">get_spectra</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_spectra" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy.array of all spectrum objects</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_tabs">
<code class="sig-name descname"><span class="pre">get_tabs</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_tabs" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy array of absolute time stamps</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_trel">
<code class="sig-name descname"><span class="pre">get_trel</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_trel" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy array of elapsed time stamps</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_x">
<code class="sig-name descname"><span class="pre">get_x</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_x" title="Permalink to this definition">¶</a></dt>
<dd><p>Return list of all spectrum objects</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.get_xsize">
<code class="sig-name descname"><span class="pre">get_xsize</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.get_xsize" title="Permalink to this definition">¶</a></dt>
<dd><p>Return number of x values</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.integrals">
<code class="sig-name descname"><span class="pre">integrals</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.integrals" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numerical integrals in xrange</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.intensities_at">
<code class="sig-name descname"><span class="pre">intensities_at</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">PointsToAverage</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.intensities_at" title="Permalink to this definition">¶</a></dt>
<dd><p>Return mean intensity at x</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.intensities_at_blc">
<code class="sig-name descname"><span class="pre">intensities_at_blc</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">PointsToAverage</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.intensities_at_blc" title="Permalink to this definition">¶</a></dt>
<dd><p>Return mean intensities at xValue corrected by baseline values. 
Attention: baselines should be defined in the region, for instance
by set_peaklimit method. Otherwise an error is raised or the returned 
values are not useful.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.max_positions">
<code class="sig-name descname"><span class="pre">max_positions</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.max_positions" title="Permalink to this definition">¶</a></dt>
<dd><p>Return x values of maximum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.max_values">
<code class="sig-name descname"><span class="pre">max_values</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.max_values" title="Permalink to this definition">¶</a></dt>
<dd><p>Return maximum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.min_positions">
<code class="sig-name descname"><span class="pre">min_positions</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.min_positions" title="Permalink to this definition">¶</a></dt>
<dd><p>Return x values of minimum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.min_values">
<code class="sig-name descname"><span class="pre">min_values</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.min_values" title="Permalink to this definition">¶</a></dt>
<dd><p>Return minimum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.peak_areas">
<code class="sig-name descname"><span class="pre">peak_areas</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.peak_areas" title="Permalink to this definition">¶</a></dt>
<dd><p>Return areas of the baseline corrected peaks between xmin and xmax</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.set_cname">
<code class="sig-name descname"><span class="pre">set_cname</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cName</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.set_cname" title="Permalink to this definition">¶</a></dt>
<dd><p>Set unit of time. Not necessary when timestamps are of class 
datetime.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.set_cunit">
<code class="sig-name descname"><span class="pre">set_cunit</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cUnit</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.set_cunit" title="Permalink to this definition">¶</a></dt>
<dd><p>Set unit of time. Not necessary when timestamps are of class 
datetime.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.SpectralSeries.set_peaklimit">
<code class="sig-name descname"><span class="pre">set_peaklimit</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSeries.set_peaklimit" title="Permalink to this definition">¶</a></dt>
<dd><p>set peaklimits xrange= [xmin, xmax]</p>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt id="specage.spcl.SpectralSum">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">specage.spcl.</span></code><code class="sig-name descname"><span class="pre">SpectralSum</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">spectra_list</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.SpectralSum" title="Permalink to this definition">¶</a></dt>
<dd><p>Merged Spectra whose sum is another full spectrum. Can for instance be 
used for peak fitting results, or concatenating spectra over different 
Energy ranges. 
TODO: needs to be programmed, should have the same methods and attributes
as Spectrum Class (+other specific methods &amp; attributes) so it can be used 
in TimeSeries Class and others.</p>
</dd></dl>

<dl class="py class">
<dt id="specage.spcl.Spectrum">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">specage.spcl.</span></code><code class="sig-name descname"><span class="pre">Spectrum</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">intensity</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">t</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xlabel</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">ylabel</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">FileName</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">comment</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum" title="Permalink to this definition">¶</a></dt>
<dd><p>Basic spectral data (X: wavelength, frequency, energy, … and 
Y: intensity, absorbance, …), time stamps and methods for interpretation.
t: should be datetime.datetime object for full functionality.</p>
<dl class="py method">
<dt id="specage.spcl.Spectrum.get_closestxind">
<code class="sig-name descname"><span class="pre">get_closestxind</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">XValue</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_closestxind" title="Permalink to this definition">¶</a></dt>
<dd><p>Return index of value in x closest to XValue</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_filename">
<code class="sig-name descname"><span class="pre">get_filename</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_filename" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the file name.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_intat">
<code class="sig-name descname"><span class="pre">get_intat</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xValue</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">PointsToAverage</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_intat" title="Permalink to this definition">¶</a></dt>
<dd><p>Return mean intensity at xValue</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_intat_blc">
<code class="sig-name descname"><span class="pre">get_intat_blc</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xValue</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">PointsToAverage</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_intat_blc" title="Permalink to this definition">¶</a></dt>
<dd><p>Return mean intensity at xValue corrected by baseline values. 
Attention: baseline should be defined in the region, for instance
by set_peaklimit method. Otherwise the returned values are not useful.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_intensity">
<code class="sig-name descname"><span class="pre">get_intensity</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_intensity" title="Permalink to this definition">¶</a></dt>
<dd><p>Return intensity as numpy array.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_max">
<code class="sig-name descname"><span class="pre">get_max</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_max" title="Permalink to this definition">¶</a></dt>
<dd><p>Return x and intensity of maximum intensity in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_min">
<code class="sig-name descname"><span class="pre">get_min</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_min" title="Permalink to this definition">¶</a></dt>
<dd><p>Return x and intensity of minimum intensity in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_numintegral">
<code class="sig-name descname"><span class="pre">get_numintegral</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_numintegral" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numerical integral calculated by trapezoidal rule in the 
in the x-range defined by set_peaklimit()</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_peak">
<code class="sig-name descname"><span class="pre">get_peak</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_peak" title="Permalink to this definition">¶</a></dt>
<dd><p>Return array containig the x-range, the intensity and the linear 
baseline defined by set_peaklimit()</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_peakarea">
<code class="sig-name descname"><span class="pre">get_peakarea</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_peakarea" title="Permalink to this definition">¶</a></dt>
<dd><p>Return area under peak (baseline corrected) in the x-range 
defined by set_peaklimit()</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_peakbaseline">
<code class="sig-name descname"><span class="pre">get_peakbaseline</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_peakbaseline" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a linear baseline in the x-range defined by set_peaklimit()</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_t">
<code class="sig-name descname"><span class="pre">get_t</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_t" title="Permalink to this definition">¶</a></dt>
<dd><p>Return time stamp</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.get_x">
<code class="sig-name descname"><span class="pre">get_x</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.get_x" title="Permalink to this definition">¶</a></dt>
<dd><p>Return x as numpy array.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.normalize">
<code class="sig-name descname"><span class="pre">normalize</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">normalizationValue</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.normalize" title="Permalink to this definition">¶</a></dt>
<dd><p>tbd</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.peakarea_calc">
<code class="sig-name descname"><span class="pre">peakarea_calc</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xmin</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xmax</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.peakarea_calc" title="Permalink to this definition">¶</a></dt>
<dd><p>Return area under baseline corrected intensity between xmin and xmax</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.plot">
<code class="sig-name descname"><span class="pre">plot</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">ax</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">plotColor</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'blue'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">showComment</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">plotBLcorrectedPeak</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">labl</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[]</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.plot" title="Permalink to this definition">¶</a></dt>
<dd><p>Plot the spectrum in the matplotlib.axes ax. Probably one should not use this</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.set_peakfitresults">
<code class="sig-name descname"><span class="pre">set_peakfitresults</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">peakseries</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fitresults</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.set_peakfitresults" title="Permalink to this definition">¶</a></dt>
<dd><p>set the results of peak fitting peakseries should be SpectralSeries 
object</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.Spectrum.set_peaklimit">
<code class="sig-name descname"><span class="pre">set_peaklimit</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">XLim</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.Spectrum.set_peaklimit" title="Permalink to this definition">¶</a></dt>
<dd><p>Define x-limits for peak area calculation.</p>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt id="specage.spcl.TimeSeries">
<em class="property"><span class="pre">class</span> </em><code class="sig-prename descclassname"><span class="pre">specage.spcl.</span></code><code class="sig-name descname"><span class="pre">TimeSeries</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">ListofSpectra</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">FileNames</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">[]</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">t0Idx</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">TimeUnit</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">''</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries" title="Permalink to this definition">¶</a></dt>
<dd><p>Merged Spectrum or SpectralSum objects, giving access to interpretation 
of time dependent spectral variations.</p>
<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_filenames">
<code class="sig-name descname"><span class="pre">get_filenames</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_filenames" title="Permalink to this definition">¶</a></dt>
<dd><p>Return filenames</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_intarr">
<code class="sig-name descname"><span class="pre">get_intarr</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_intarr" title="Permalink to this definition">¶</a></dt>
<dd><p>Return array of intensities.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_size">
<code class="sig-name descname"><span class="pre">get_size</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_size" title="Permalink to this definition">¶</a></dt>
<dd><p>Return number of spectrum objects</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_spectra">
<code class="sig-name descname"><span class="pre">get_spectra</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_spectra" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy.array of all spectrum objects</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_tabs">
<code class="sig-name descname"><span class="pre">get_tabs</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_tabs" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy array of absolute time stamps</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_trel">
<code class="sig-name descname"><span class="pre">get_trel</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_trel" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numpy array of elapsed time stamps</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_tunit">
<code class="sig-name descname"><span class="pre">get_tunit</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_tunit" title="Permalink to this definition">¶</a></dt>
<dd><p>Return unit of time. Not necessary when timestamps are of class 
datetime.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_x">
<code class="sig-name descname"><span class="pre">get_x</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_x" title="Permalink to this definition">¶</a></dt>
<dd><p>Return list of all spectrum objects</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.get_xsize">
<code class="sig-name descname"><span class="pre">get_xsize</span></code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.get_xsize" title="Permalink to this definition">¶</a></dt>
<dd><p>Return number of x values</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.integrals">
<code class="sig-name descname"><span class="pre">integrals</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.integrals" title="Permalink to this definition">¶</a></dt>
<dd><p>Return numerical integrals in xrange</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.intensities_at">
<code class="sig-name descname"><span class="pre">intensities_at</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">PointsToAverage</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.intensities_at" title="Permalink to this definition">¶</a></dt>
<dd><p>Return mean intensity at x</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.intensities_at_blc">
<code class="sig-name descname"><span class="pre">intensities_at_blc</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">PointsToAverage</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.intensities_at_blc" title="Permalink to this definition">¶</a></dt>
<dd><p>Return mean intensities at xValue corrected by baseline values. 
Attention: baselines should be defined in the region, for instance
by set_peaklimit method. Otherwise an error is raised or the returned 
values are not useful.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.max_positions">
<code class="sig-name descname"><span class="pre">max_positions</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.max_positions" title="Permalink to this definition">¶</a></dt>
<dd><p>Return x values of maximum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.max_values">
<code class="sig-name descname"><span class="pre">max_values</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.max_values" title="Permalink to this definition">¶</a></dt>
<dd><p>Return maximum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.meanint_trel">
<code class="sig-name descname"><span class="pre">meanint_trel</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t_range</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.meanint_trel" title="Permalink to this definition">¶</a></dt>
<dd><p>Return mean intensities of the time interval t_range.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.min_positions">
<code class="sig-name descname"><span class="pre">min_positions</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.min_positions" title="Permalink to this definition">¶</a></dt>
<dd><p>Return x values of minimum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.min_values">
<code class="sig-name descname"><span class="pre">min_values</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.min_values" title="Permalink to this definition">¶</a></dt>
<dd><p>Return minimum intensities in xrange.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.peak_areas">
<code class="sig-name descname"><span class="pre">peak_areas</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xrange</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.peak_areas" title="Permalink to this definition">¶</a></dt>
<dd><p>Return areas of the baseline corrected peaks between xmin and xmax</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.set_t0">
<code class="sig-name descname"><span class="pre">set_t0</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t0</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.set_t0" title="Permalink to this definition">¶</a></dt>
<dd><p>Set t0 manually and return numpy array of elapsed time stamps. t0
should be datetime.datetime object.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.set_t0idx">
<code class="sig-name descname"><span class="pre">set_t0idx</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t0Idx</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.set_t0idx" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the index of the initial measurement (0 by default) and return 
numpy array of elapsed time stamps</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.set_tunit">
<code class="sig-name descname"><span class="pre">set_tunit</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">tUnit</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.set_tunit" title="Permalink to this definition">¶</a></dt>
<dd><p>Set unit of time. Not necessary when timestamps are of class 
datetime.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.tabs_rangebool">
<code class="sig-name descname"><span class="pre">tabs_rangebool</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t_range</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.tabs_rangebool" title="Permalink to this definition">¶</a></dt>
<dd><p>Return boolean mask that is true for intervall t_range in t_abs and 
false elsewhere. t_range maybe list of datetime.datetime objects, 
or timestamps. TODO: this has not been properly tested,yet</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.tabs_rangeind">
<code class="sig-name descname"><span class="pre">tabs_rangeind</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t_range</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.tabs_rangeind" title="Permalink to this definition">¶</a></dt>
<dd><p>Return indeces for intervall t_range in t_abs. t_range maybe list of
datetime.datetime objects, or timestamps. TODO: this has not been 
properly tested,yet</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.temporalmean">
<code class="sig-name descname"><span class="pre">temporalmean</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">boxwidth</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.temporalmean" title="Permalink to this definition">¶</a></dt>
<dd><p>Return new TimeSeries object with averaged spectra. The number of 
spectra to be averaged is determined by boxwidth. Attention: Comments 
of the original data set are lost in this operation.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.trel_ind">
<code class="sig-name descname"><span class="pre">trel_ind</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.trel_ind" title="Permalink to this definition">¶</a></dt>
<dd><p>Return index of t_rel value closest to t</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.trel_rangebool">
<code class="sig-name descname"><span class="pre">trel_rangebool</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t_range</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.trel_rangebool" title="Permalink to this definition">¶</a></dt>
<dd><p>Return boolean mask that is true for intervall t_range in t_rel and 
false elsewhere.</p>
</dd></dl>

<dl class="py method">
<dt id="specage.spcl.TimeSeries.trel_rangeind">
<code class="sig-name descname"><span class="pre">trel_rangeind</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">t_range</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.spcl.TimeSeries.trel_rangeind" title="Permalink to this definition">¶</a></dt>
<dd><p>Return indeces for intervall t_range in t_rel</p>
</dd></dl>

</dd></dl>

</section>
<section id="modules-for-spectral-analysis">
<h2>Modules for Spectral Analysis<a class="headerlink" href="#modules-for-spectral-analysis" title="Permalink to this headline">¶</a></h2>
<p>ascii_magic module:</p>
<blockquote>
<div><span class="target" id="module-specage.ascii_magic"></span><p>Created on Thu Apr  5 10:51:14 2018
Helpful functions for ASCII readers.
&#64;authors: Martin Rabe, S.Tecklenburg</p>
<dl class="py function">
<dt id="specage.ascii_magic.comma_replace">
<code class="sig-prename descclassname"><span class="pre">specage.ascii_magic.</span></code><code class="sig-name descname"><span class="pre">comma_replace</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filename</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ascii_magic.comma_replace" title="Permalink to this definition">¶</a></dt>
<dd><p>Replace all ‘,’ within a file with ‘.’ and save it as filename.crp</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ascii_magic.find_line">
<code class="sig-prename descclassname"><span class="pre">specage.ascii_magic.</span></code><code class="sig-name descname"><span class="pre">find_line</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filename</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">linestring</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ascii_magic.find_line" title="Permalink to this definition">¶</a></dt>
<dd><p>Return indeces of all full line appearances of linestring in filename.</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ascii_magic.find_str_in_line">
<code class="sig-prename descclassname"><span class="pre">specage.ascii_magic.</span></code><code class="sig-name descname"><span class="pre">find_str_in_line</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filename</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">substr</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ascii_magic.find_str_in_line" title="Permalink to this definition">¶</a></dt>
<dd><p>Return indeces of all appearances of substr in the lines of filename.</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ascii_magic.readASCII_file">
<code class="sig-prename descclassname"><span class="pre">specage.ascii_magic.</span></code><code class="sig-name descname"><span class="pre">readASCII_file</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ascii_magic.readASCII_file" title="Permalink to this definition">¶</a></dt>
<dd><p>Return all lines of the file in a list</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ascii_magic.readASCII_table">
<code class="sig-prename descclassname"><span class="pre">specage.ascii_magic.</span></code><code class="sig-name descname"><span class="pre">readASCII_table</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">headlines</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ascii_magic.readASCII_table" title="Permalink to this definition">¶</a></dt>
<dd><p>Read simple table from ASCII file with defined number of headerlines and
delimiter and return data as numpy array and headerlines as list. Hint: 
delim = None treats consecutive whitespace as single separator and also 
works with leading or trailing whitespace.</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ascii_magic.readlines">
<code class="sig-prename descclassname"><span class="pre">specage.ascii_magic.</span></code><code class="sig-name descname"><span class="pre">readlines</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filename</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">linenumbers</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ascii_magic.readlines" title="Permalink to this definition">¶</a></dt>
<dd><p>Return lines with the linenumbers in the ascii file filename. linenumbers 
should behave like a list of integers. Hint:
to get the content of all lines that contain a specific string, use: 
content = readlines(filename, find_str_in_line(filename, string))</p>
</dd></dl>

</div></blockquote>
<p>peakfit module:</p>
<blockquote>
<div><span class="target" id="module-specage.peakfit"></span><p>Created on Fri Jul 27 11:08:34 2018
rewrote to generalized form: Nov 24, 2021
provides functions for peak fitting. Different peak shapes will be integrated 
over time. Right now available: Gaussians.
This module still could use some development.</p>
<dl>
<dt>TODOs:</dt><dd><p>Add other peakfunctions. (Lorentzian)</p>
<p>In the current implementation, a significant limitation to the peak function 
is, that it can have only exactly 3 parameters: 
size (height or area), x-position, width.</p>
<p>Furthermore, currently no baseline fitting is implemented.</p>
<p>A full integration into specage would also make use of the yet to be 
developped SpectralSum class.</p>
</dd>
</dl>
<p>&#64;author: MR</p>
<dl class="py function">
<dt id="specage.peakfit.addpeaks">
<code class="sig-prename descclassname"><span class="pre">specage.peakfit.</span></code><code class="sig-name descname"><span class="pre">addpeaks</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">size_lst</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xpos_lst</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">w_lst</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">peakfunc</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.peakfit.addpeaks" title="Permalink to this definition">¶</a></dt>
<dd><p>Return Value of sum  of peaks whose shapes are defined by peakfunc. 
The peaks are defined by the lists size (can be height or area), xpos, w
which all must have the same length and whos length determines the number 
of peaks.</p>
</dd></dl>

<dl class="py function">
<dt id="specage.peakfit.gaussianamp">
<code class="sig-prename descclassname"><span class="pre">specage.peakfit.</span></code><code class="sig-name descname"><span class="pre">gaussianamp</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">h</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xpos</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">w</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.peakfit.gaussianamp" title="Permalink to this definition">¶</a></dt>
<dd><p>Return value of gaussian. x may be numpy.array. h: height, 
xpos: position, w: width. Hint: The area under the curve can be calculated
by: A= h*sqrt(2*pi*(w**2))</p>
</dd></dl>

<dl class="py function">
<dt id="specage.peakfit.gaussianarea">
<code class="sig-prename descclassname"><span class="pre">specage.peakfit.</span></code><code class="sig-name descname"><span class="pre">gaussianarea</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">A</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xpos</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fwhm</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.peakfit.gaussianarea" title="Permalink to this definition">¶</a></dt>
<dd><p>another form of the gaussian using the area and fwhm as parameters</p>
</dd></dl>

<dl class="py function">
<dt id="specage.peakfit.peak_sum">
<code class="sig-prename descclassname"><span class="pre">specage.peakfit.</span></code><code class="sig-name descname"><span class="pre">peak_sum</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">params</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fitparbool</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixedparameters</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">peakfunc</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.peakfit.peak_sum" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns sum of peaks and single peaks at x. Function 
is designed to work as input for scipy.optimize.least_squares(). Allows 
specific parameters to be set as fixed. 
All arguments must be numpy.array.
fitparbool: [h1, xpos1, w1, h2, …] With the elements 
being Boolean to indicate if the parameter is a fit parameter.
params: np.array of the form [fitparbool]
fixedparameters: np.array of the form [~fitparbool]</p>
</dd></dl>

<dl class="py function">
<dt id="specage.peakfit.peak_sumres">
<code class="sig-prename descclassname"><span class="pre">specage.peakfit.</span></code><code class="sig-name descname"><span class="pre">peak_sumres</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">params</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">x</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">y</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fitparbool</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixedparameters</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">peakfunc</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.peakfit.peak_sumres" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns residuals of sum of peaks with respect to y at x. Function 
is designed to work as input for scipy.optimize.least_squares(). Allows 
specific parameters to be set as fixed. 
All arguments must be numpy.array.
fitparbool: [h1, xpos1, w1, h2, …] With the elements 
being Boolean to indicate if the parameter is a fit parameter.
params: np.array of the form [fitparbool]
fixedparameters: np.array of the form [~fitparbool]</p>
</dd></dl>

</div></blockquote>
<dl>
<dt>unit_convert module:</dt><dd><span class="target" id="module-specage.unit_convert"></span><p>Created on Thu Sep 20 10:08:23 2018
Helpful functions for unit conversions.
&#64;author: Martin Rabe</p>
<dl class="py function">
<dt id="specage.unit_convert.eV2nm">
<code class="sig-prename descclassname"><span class="pre">specage.unit_convert.</span></code><code class="sig-name descname"><span class="pre">eV2nm</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">eV</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.unit_convert.eV2nm" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns wavelength [nm] from energy [eV]</p>
</dd></dl>

<dl class="py function">
<dt id="specage.unit_convert.nm2eV">
<code class="sig-prename descclassname"><span class="pre">specage.unit_convert.</span></code><code class="sig-name descname"><span class="pre">nm2eV</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">nm</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.unit_convert.nm2eV" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns energy [eV] from wavelength [nm]</p>
</dd></dl>

<dl class="py function">
<dt id="specage.unit_convert.nm2wavenum">
<code class="sig-prename descclassname"><span class="pre">specage.unit_convert.</span></code><code class="sig-name descname"><span class="pre">nm2wavenum</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">nm</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.unit_convert.nm2wavenum" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns wavenumber [cm⁻¹] from wavelength [nm]</p>
</dd></dl>

<dl class="py function">
<dt id="specage.unit_convert.wavenum2nm">
<code class="sig-prename descclassname"><span class="pre">specage.unit_convert.</span></code><code class="sig-name descname"><span class="pre">wavenum2nm</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">wavenum</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.unit_convert.wavenum2nm" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns wavelength [nm] from wavenumber [cm⁻¹]</p>
</dd></dl>

</dd>
</dl>
</section>
<section id="readers">
<h2>Readers<a class="headerlink" href="#readers" title="Permalink to this headline">¶</a></h2>
<p>IR-readers:</p>
<blockquote>
<div><span class="target" id="module-specage.ir_readers"></span><p>Readers for files created Brukers and BioRads IR spektrometer software</p>
<dl class="py function">
<dt id="specage.ir_readers.AFMIR_csv">
<code class="sig-prename descclassname"><span class="pre">specage.ir_readers.</span></code><code class="sig-name descname"><span class="pre">AFMIR_csv</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">csvfile</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ir_readers.AFMIR_csv" title="Permalink to this definition">¶</a></dt>
<dd><p>Reads single csv file created by AFMIR and returns a list of Spectrum 
objects.</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ir_readers.biorad_csv">
<code class="sig-prename descclassname"><span class="pre">specage.ir_readers.</span></code><code class="sig-name descname"><span class="pre">biorad_csv</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">csvfile</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ir_readers.biorad_csv" title="Permalink to this definition">¶</a></dt>
<dd><p>Read single csv file created by BioRads software and return a
Spectrum object</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ir_readers.biorad_multicsv">
<code class="sig-prename descclassname"><span class="pre">specage.ir_readers.</span></code><code class="sig-name descname"><span class="pre">biorad_multicsv</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Filelist</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ir_readers.biorad_multicsv" title="Permalink to this definition">¶</a></dt>
<dd><p>Return list of Spectrum s from list of csv files from Boprad software</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ir_readers.bruk_dpt">
<code class="sig-prename descclassname"><span class="pre">specage.ir_readers.</span></code><code class="sig-name descname"><span class="pre">bruk_dpt</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">dptfile</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ir_readers.bruk_dpt" title="Permalink to this definition">¶</a></dt>
<dd><p>Read single dpt file created by Brukers OPUS software and return a
Spectrum object</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ir_readers.bruk_multidpt">
<code class="sig-prename descclassname"><span class="pre">specage.ir_readers.</span></code><code class="sig-name descname"><span class="pre">bruk_multidpt</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filelist</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ir_readers.bruk_multidpt" title="Permalink to this definition">¶</a></dt>
<dd><p>Read multiple dpt files created by Brukers OPUS software and return list 
of Spectrum objects</p>
</dd></dl>

</div></blockquote>
<p>OceanOptics readers:</p>
<blockquote>
<div><span class="target" id="module-specage.ov_readers"></span><p>Readers for ASCII spectra files created by OceanOptics OveanView (R)</p>
<dl class="py function">
<dt id="specage.ov_readers.single_spectrum">
<code class="sig-prename descclassname"><span class="pre">specage.ov_readers.</span></code><code class="sig-name descname"><span class="pre">single_spectrum</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filename</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ov_readers.single_spectrum" title="Permalink to this definition">¶</a></dt>
<dd><p>Read single spectrum file and return Spectrum object.</p>
</dd></dl>

<dl class="py function">
<dt id="specage.ov_readers.spectra_time_series">
<code class="sig-prename descclassname"><span class="pre">specage.ov_readers.</span></code><code class="sig-name descname"><span class="pre">spectra_time_series</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filename</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.ov_readers.spectra_time_series" title="Permalink to this definition">¶</a></dt>
<dd><p>Read Time Series of spectra and returns ‘TimeSeries’ object.</p>
</dd></dl>

</div></blockquote>
<p>Raman readers:</p>
<blockquote>
<div><span class="target" id="module-specage.witec_readers"></span><p>Readers for ASCII files exported from Witec ‘Project Five’ Software.</p>
<dl class="py function">
<dt id="specage.witec_readers.multi_witASCII">
<code class="sig-prename descclassname"><span class="pre">specage.witec_readers.</span></code><code class="sig-name descname"><span class="pre">multi_witASCII</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">filelist</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.witec_readers.multi_witASCII" title="Permalink to this definition">¶</a></dt>
<dd><p>Read multiple ASCII files created by Witecs ‘Project Five’ software and 
return list of Spectrum objects</p>
</dd></dl>

<dl class="py function">
<dt id="specage.witec_readers.witASCII">
<code class="sig-prename descclassname"><span class="pre">specage.witec_readers.</span></code><code class="sig-name descname"><span class="pre">witASCII</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.witec_readers.witASCII" title="Permalink to this definition">¶</a></dt>
<dd><p>Read single ASCII file created by Witecs ‘Project Five’ software and 
return a Spectrum object</p>
</dd></dl>

</div></blockquote>
<p>Perkin-Elmer UV/Vis readers</p>
<blockquote>
<div><span class="target" id="module-specage.peuvvis_readers"></span><p>Functions for reading Pekin Elmer UV/Vis spectroscopic data provided by UV WinLab 
software</p>
<dl class="py function">
<dt id="specage.peuvvis_readers.filelist">
<code class="sig-prename descclassname"><span class="pre">specage.peuvvis_readers.</span></code><code class="sig-name descname"><span class="pre">filelist</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Filelist</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.peuvvis_readers.filelist" title="Permalink to this definition">¶</a></dt>
<dd><p>Return list of Spectrum object from list of UVWinlab ascii files</p>
</dd></dl>

<dl class="py function">
<dt id="specage.peuvvis_readers.singleascii">
<code class="sig-prename descclassname"><span class="pre">specage.peuvvis_readers.</span></code><code class="sig-name descname"><span class="pre">singleascii</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Filename</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.peuvvis_readers.singleascii" title="Permalink to this definition">¶</a></dt>
<dd><p>Return Spectrum object from UVWinlab ascii file</p>
</dd></dl>

</div></blockquote>
<p>Special software readers:</p>
<blockquote>
<div><span class="target" id="module-specage.wvr_reader"></span><p>Functions for reading Output from MatLab Program ‘WaterVapRemover’</p>
<dl class="py function">
<dt id="specage.wvr_reader.filelist">
<code class="sig-prename descclassname"><span class="pre">specage.wvr_reader.</span></code><code class="sig-name descname"><span class="pre">filelist</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Filelist</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">blcorr</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.wvr_reader.filelist" title="Permalink to this definition">¶</a></dt>
<dd><p>Return list of Spectrum object from list of ‘WaterVapRemover’ ascii files</p>
</dd></dl>

<dl class="py function">
<dt id="specage.wvr_reader.singleascii">
<code class="sig-prename descclassname"><span class="pre">specage.wvr_reader.</span></code><code class="sig-name descname"><span class="pre">singleascii</span></code><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Filename</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">blcorr</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#specage.wvr_reader.singleascii" title="Permalink to this definition">¶</a></dt>
<dd><p>Return Spectrum object from ‘WaterVapRemover’ ascii file. For 
blcorr = true the baseline corrected spectrum is read</p>
</dd></dl>

</div></blockquote>
</section>
</section>
<section id="indices-and-tables">
<h1>Indices and tables<a class="headerlink" href="#indices-and-tables" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><a class="reference internal" href="genindex.html"><span class="std std-ref">Index</span></a></p></li>
<li><p><a class="reference internal" href="py-modindex.html"><span class="std std-ref">Module Index</span></a></p></li>
<li><p><a class="reference internal" href="search.html"><span class="std std-ref">Search Page</span></a></p></li>
</ul>
</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="#">specage</a></h1>








<h3>Navigation</h3>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="#">Documentation overview</a><ul>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2018, Martin Rabe.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.5.2</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/index.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>